/******************** (C) COPYRIGHT 2012 MJX ****************************************************************************
* File Name          : main.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378 USB豸ù̼ӳ
*                      : KEIL 4.10
*    				   MCS51ƬCԵCH378豸ģʽӳ 							 										      
****************************************************************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "CH378INC.H"											 /* CH378ͷļ */	
#include "HAL.H"												 /* Ӳͷļ */
#include "HAL_BASE.C"											 /* Ӳӳļ */
#include "DEBUG.H"												 /* ӳͷļ */
#include "DEBUG.C"												 /* ӳļ */

/*******************************************************************************/
/* ѡͨѶӿ */
#define	IC_OP_INTERFACE_MODE	 3							 	 /* оƬӿģʽ(1:Ӳ;  2:ģⲢ; 
                                                                    	                 3:ӲSPI; 4:ģSPI; 5:첽) */                                                                    
#if    ( IC_OP_INTERFACE_MODE == 1 )
#include "../myfile/PARA_HW.C"						 			 /* Ӳ߲ӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 2 )
#include "../myfile/PARA_SW.C"						 			 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
#include "../myfile/SPI_HW.C"						 			 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
#include "../myfile/SPI_SW.C"						 			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
#include "../myfile/UART_HW.C"						 			 /* Ӳ첽ӷʽ */
#else
#error: You Must Include Right Interface Operate File!!!
#endif

/*******************************************************************************/
/*  */ 
UINT8  Dev_Buf[ 512 ];

/*******************************************************************************
* Function Name  : mInitCH378Device
* Description    : ʼCH378豸ģʽ
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 mInitCH378Device( void ) 
{
	UINT8  res;

	/* CH378Ƿ */	
	CH378_Port_Init( );  										 /* ӿӲʼ */
	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x65 );
	res = xReadCH378Data( );
	xEndCH378Cmd( );
	if( res != 0x9A ) 
	{
		/* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}	

#ifdef	UART_WORK_BAUDRATE
	/* CH378ͨŲ */
	xWriteCH378Cmd( CMD31_SET_BAUDRATE );  						  /* ôͨѶ */
	xWriteCH378Data( (UINT8)UART_WORK_BAUDRATE );
	xWriteCH378Data( (UINT8)( UART_WORK_BAUDRATE >> 8 ) );
	xWriteCH378Data( (UINT8)( UART_WORK_BAUDRATE >> 16 ) );
	xEndCH378Cmd( );  											 /* 첽ڷʽҪ */

	/* õƬͨŲ */
	mDelaymS( 3 );  
	Set_MCU_BaudRate( );  										 /* ƬлʽͨѶ */

	/* ͨȡִ״̬жϸǷִгɹ */
	if( Check_Cmd_OpStatus( ) != CMD_RET_SUCCESS ) 
	{
		return( ERR_USB_UNKNOWN );  							 /* ͨѶлʧ,ͨӲλCH378 */
	}
#endif

#if  0
	/* VIDPID */
	xWriteCH378Cmd( CMD40_SET_USB_ID );  						 /* 豸оƬVIDPID */
	xWriteCH378Data( 0x43 );									 			
	xWriteCH378Data( 0x48 );									 			
	xWriteCH378Data( 0x55 );									 			
	xWriteCH378Data( 0x37 );									 			
	xEndCH378Cmd( );
#endif

#if  0
	/* USB ٶ */
	xWriteCH378Cmd( CMD10_SET_USB_SPEED );  					 /* 豸оƬUSBٶ */
	xWriteCH378Data( 0x00 );									 /* ȫģʽ */									 												 			
	xEndCH378Cmd( );
#endif

	/* CH378ģʽ */
	xWriteCH378Cmd( CMD11_SET_USB_MODE );  						 /* 豸USBģʽ */
	xWriteCH378Data( 0x02 );									 /* ù̼ģʽ */

	/* ȴģʽ,ڲSDҪ10mSʱ,ڲUSB豸Ҫ35mSʱ */	
	mDelaymS( 50 );											 
	res = xReadCH378Data( );
	xEndCH378Cmd( );

#ifndef	CH378_INT_WIRE
	xWriteCH378Cmd( CMD20_SET_SDO_INT );  						 /* SPISDOŵжϷʽ */
	xWriteCH378Data( 0x16 );
	xWriteCH378Data( 0x01 );  									 /* SDOSCSƬѡЧʱж */
	xEndCH378Cmd( );
#endif
	if( res == CMD_RET_SUCCESS ) 
	{
		return( ERR_SUCCESS );
	}
	else 
	{
		return( ERR_USB_UNKNOWN );  							 /* ģʽ */
	}
}

/*******************************************************************************
* Function Name  : main
* Description    : Main routine.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void )
{
	UINT8  status;
	UINT16 len, l;
	UINT8  *pbuf;
	
	mDelaymS( 100 );  											 /* ʱ100 */
	mInitSTDIO( );  											 /* Ϊüͨڼʾ */

#if    ( IC_OP_INTERFACE_MODE == 1 )
	printf(" MCS51_CH378_PARA_HW V1.2 2015.08.28...\n");		 /* Ӳ߲ӷʽ */						 			 
#elif  ( IC_OP_INTERFACE_MODE == 2 )
	printf(" MCS51_CH378_PARA_SW V1.2 2015.08.28...\n"); 		 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
	printf(" MCS51_CH378_SPI_HW V1.2 2015.08.28...\n"); 		 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
	printf(" MCS51_CH378_SPI_SW V1.2 2015.08.28...\n");			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
	printf(" MCS51_CH378_UART_HW V1.2 2015.08.28...\n");		 /* Ӳ첽ӷʽ */
#else
	printf(" MCS51_CH378_INTERFACE ERROR 2015.08.28...\n");
#endif

	printf( "Test Start\n" );
	mDelaymS( 200 );
	status = mInitCH378Device( );  								 /* ʼCH378豸ģʽ */
	mStopIfError( status );
	/* ·ʼ */

	while( 1 )
	{
		if( Query378Interrupt( ) ) 	   							 /* ⵽ж */	
		{
			/* ȡж״̬ */
			xWriteCH378Cmd( CMD01_GET_STATUS );					 /* Ͷȡж״̬ */
			status = xReadCH378Data( );
			xEndCH378Cmd( );
			switch( status )
			{
				case USB_INT_INDEX1_IN:							 /* 1ӦĶ˵ϴɹж */
					printf("INDEX1_IN\n");
					break;

				case USB_INT_INDEX2_OUT:						 /* 2ӦĶ˵´ɹж */
					printf("INDEX2_OUT\n");
					pbuf = Dev_Buf;
					xWriteCH378Cmd( CMD1x_RD_USB_DATA );		 /* ָUSBжϵĶ˵㻺ȡݿ,ͷŻ */		
					xWriteCH378Data( ENDP_INDEX_2 );			 /* ˵ */
					len = xReadCH378Data( );
					len += ( ( UINT16 )xReadCH378Data( ) << 8 ); /* ȡ2ֽݳ */
					mDelayuS( 1 ); 								 /* ڸMCU,ڴ˴ʵʱ */		
					l = len;
					if( len )									 /* ѭȡݿ */
					{
						do
						{		
							*pbuf = xReadCH378Data( );	
							pbuf++;
						}while( --l );		
					}
					xEndCH378Cmd( );

					/* ͨӦϴ˵شݰ */
					pbuf = Dev_Buf;
					xWriteCH378Cmd( CMD30_WR_USB_DATA );		 /* ָUSB˵ķͻдݿ */		
					xWriteCH378Data( ENDP_INDEX_1 ); 		     /* ˵ */
					xWriteCH378Data( ( UINT8 )len );
					xWriteCH378Data( ( UINT8 )( len >> 8 ) );
					mDelayuS( 1 ); 								 /* ڸMCU,ڴ˴ʵʱ */							
					l = len;
					if( len )
					{
						do
						{		
							xWriteCH378Data( *pbuf++ );			 /* ѭдݿ */
						}while( --l );		
					}
					xEndCH378Cmd( );
					break;

				case USB_INT_INDEX3_IN:							 /* 3ӦĶ˵ϴɹж */
					printf("INDEX3_IN\n");
					break;

				case USB_INT_INDEX4_OUT:						 /* 4ӦĶ˵´ɹж */
					printf("INDEX4_OUT \n");
					pbuf = Dev_Buf;
					xWriteCH378Cmd( CMD1x_RD_USB_DATA );		 /* ָUSBжϵĶ˵㻺ȡݿ,ͷŻ */		
					xWriteCH378Data( ENDP_INDEX_4 );		   	 /* ˵ */
					len = xReadCH378Data( );
					len += ( ( UINT16 )xReadCH378Data( ) << 8 ); /* ȡ2ֽݳ */
					mDelayuS( 1 ); 								 /* ڸMCU,ڴ˴ʵʱ */		
					l = len;
					if( len )									 /* ѭȡݿ */
					{
						do
						{		
							*pbuf = xReadCH378Data( );	
							pbuf++;
						}while( --l );		
					}
					xEndCH378Cmd( );

					/* ͨӦϴ˵شݰ */
					pbuf = Dev_Buf;
					xWriteCH378Cmd( CMD30_WR_USB_DATA );		 /* ָUSB˵ķͻдݿ */		
					xWriteCH378Data( ENDP_INDEX_3 );		   	 /* ˵ */
					xWriteCH378Data( ( UINT8 )len );
					xWriteCH378Data( ( UINT8 )( len >> 8 ) );
					mDelayuS( 1 ); 								 /* ڸMCU,ڴ˴ʵʱ */							
					l = len;
					if( len )
					{
						do
						{		
							xWriteCH378Data( *pbuf++ );			 /* ѭдݿ */
						}while( --l );		
					}
					xEndCH378Cmd( );
					break;

				case USB_INT_BUS_SUSP:							 /* USB߹ж */
					printf("BUS_SUSP\n");	
					break;

				case USB_INT_BUS_RESET:							 /* USB߸λж */
					printf("BUS_RESET\n");	
					break;

				case USB_INT_SET_CONFIG:						 /* USBյSET_CONFIGж */
					printf("SET_CONFIG\n");						
					                                             /* ڽյжϺ,ſԿʼϴ */				   	

				default:
				    break;
			}								 
		}
	}	
}

