/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378 ļϵͳӳ(EXAM11)
*                      USB Host File Interface for CH378
*					   TC2.0@PC, KC7.0@MCS51
*******************************************************************************/



/******************************************************************************
˵: 
    MCS-51ƬCԵUļдʾ
    ǳļʾ, ļļļĿ¼
    ӶļöӦĳļ
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "CH378INC.H"											 /* CH378ͷļ */	
#include "HAL.H"												 /* Ӳͷļ */
#include "HAL_BASE.C"											 /* Ӳӳļ */
#include "DEBUG.H"												 /* ӳͷļ */
#include "DEBUG.C"												 /* ӳļ */

/*******************************************************************************/
/* ѡͨѶӿ */
#define	IC_OP_INTERFACE_MODE	 2							 	 /* оƬӿģʽ(1:Ӳ;  2:ģⲢ; 
                                                                    	                 3:ӲSPI; 4:ģSPI; 5:첽) */                                                                    
#if    ( IC_OP_INTERFACE_MODE == 1 )
#include "PARA_HW.C"											 /* Ӳ߲ӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 2 )
#include "PARA_SW.C"										 	 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
#include "SPI_HW.C"										 	 	 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
#include "SPI_SW.C"												 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
#include "UART_HW.C"										 	 /* Ӳ첽ӷʽ */
#else
#error: You Must Include Right Interface Operate File!!!
#endif

/*******************************************************************************/
/* ѡҪĺ */
//#define EN_DISK_QUERY		  	   1							 /* ѯʣռѯӳ */
//#define EN_DIR_CREATE			   1							 /* ½༶Ŀ¼ӳ */	
//#define EN_SECTOR_ACCESS   	   1							 /* Ϊλдļӳ */		
#define EN_LONG_NAME	   		   1							 /* ֳ֧ļӳ */		
//#define EN_OTHER_FUNCTION   	   1							 /* ǳӳ */		

#include "FILE_SYS.H"											 /* ļϵͳͷļ */
#include "FILE_SYS.C"											 /* ļϵͳӳļ */

/*******************************************************************************/
/*  */
UINT16 SecterSize;												 /* ǰUÿС */  
UINT8  idata buf[ 64 ];											 /* ݻ */	
UINT8  xdata LongNameBuf[ 512 ];								 /* ļŻ */	

/*********************************************************************************************************/
/* ļʾ */

/* ע: CH378ڲUNICODEʽΪС˸ʽ,ⲿļUNICODEҲΪС˸ʽ */
UINT8 const LongName[ ] =
{
    /* LongName:
       "ļ 1.(unicode )ַĩβ0ʾ;2.ANSIļ.TXT" */
	0xFA, 0x5E, 0xCB, 0x7A, 0x7F, 0x95, 0x87, 0x65, 0xF6, 0x4E, 0x0D, 0x54, 0x0C, 0xFF, 0x93, 0x8F,
	0x65, 0x51, 0x24, 0x4E, 0x2A, 0x4E, 0xC2, 0x53, 0x70, 0x65, 0x1A, 0xFF, 0x20, 0x00, 0x31, 0x00,
	0x2E, 0x00, 0xC7, 0x91, 0x28, 0x75, 0x28, 0x00, 0x75, 0x00, 0x6E, 0x00, 0x69, 0x00, 0x63, 0x00,
	0x6F, 0x00, 0x64, 0x00, 0x65, 0x00, 0x20, 0x00, 0x27, 0x59, 0xEF, 0x7A, 0x29, 0x00, 0x0C, 0xFF,
	0x57, 0x5B, 0x26, 0x7B, 0x32, 0x4E, 0x2B, 0x67, 0x3E, 0x5C, 0x28, 0x75, 0x24, 0x4E, 0x2A, 0x4E,
	0x30, 0x00, 0x68, 0x88, 0x3A, 0x79, 0xD3, 0x7E, 0x5F, 0x67, 0x3B, 0x00, 0x32, 0x00, 0x2E, 0x00,
	0x41, 0x00, 0x4E, 0x00, 0x53, 0x00, 0x49, 0x00, 0x16, 0x7F, 0x01, 0x78, 0xED, 0x77, 0x87, 0x65,
	0xF6, 0x4E, 0x0D, 0x54, 0x2E, 0x00, 0x54, 0x00, 0x58, 0x00, 0x54, 0x00
};

UINT8 const LongDir[ ] =
{
    /* LongDir: "ʾļ" */
	0x14, 0x6F, 0x3A, 0x79, 0x1B, 0x52, 0xFA, 0x5E, 0x7F, 0x95, 0x87, 0x65, 0xF6, 0x4E, 0x39, 0x59
};
            
/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main( void ) 
{
	UINT8  status;
	UINT16 i;
	
	mDelaymS( 100 );  											 /* ʱ100 */
	mInitSTDIO( );  											 /* Ϊüͨڼʾ */

#if    ( IC_OP_INTERFACE_MODE == 1 )
	printf(" MCS51_CH378_PARA_HW V1.2 2015.08.28...\n");		 /* Ӳ߲ӷʽ */						 			 
#elif  ( IC_OP_INTERFACE_MODE == 2 )
	printf(" MCS51_CH378_PARA_SW V1.2 2015.08.28...\n"); 		 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
	printf(" MCS51_CH378_SPI_HW V1.2 2015.08.28...\n"); 		 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
	printf(" MCS51_CH378_SPI_SW V1.2 2015.08.28...\n");			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
	printf(" MCS51_CH378_UART_HW V1.2 2015.08.28...\n");		 /* Ӳ첽ӷʽ */
#else
	printf(" MCS51_CH378_INTERFACE ERROR 2015.08.28...\n");
#endif

	printf( "Start\n" );
	status = mInitCH378Host( );  								 /* ʼCH378 */								 	
	mStopIfError( status );
	/* ·ʼ */

	while( 1 ) 													 
	{
		/* U̻SDǷ,ȴ */
		printf( "Wait Udisk/SD\n" );
		while( CH378DiskConnect( ) != ERR_SUCCESS ) 
		{  
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  										 /* ʱ,ѡ,еUSB洢Ҫʮʱ */
		
		/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,
		   ȴ5*50mS,ҪDiskReady */
		for( i = 0; i < 100; i ++ ) 
		{  
			/* ȴʱ,100*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			status = CH378DiskReady( );  						 /* ʼ̲ԴǷ */
			if( status == ERR_SUCCESS ) 
			{
				break;  										 /* ׼ */
			}
			else if( status == ERR_DISK_DISCON ) 
			{
				goto UnknownUsbDevice; 							 /* ⵽Ͽ,¼Ⲣʱ */
			}
			if( CH378GetDiskStatus( ) >= DEF_DISK_MOUNTED && i >= 5 ) 
			{
				break;  										 /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
			}
		}
		if( status == ERR_DISK_DISCON ) 
		{  
			/* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;
		}
		if( CH378GetDiskStatus( ) < DEF_DISK_MOUNTED ) 
		{  
			/* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
		
		/* Ҫ,ԶȡݿCH378_CMD_DATA.DiskMountInq,س */
		i = CH378ReadReqBlock( buf );
		if( i == sizeof( INQUIRY_DATA ) ) 
		{  
			/* U̵ĳ̺ͲƷϢ */
			buf[ i ] = 0;
			printf( "Udisk Info: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
		}

		/* ȡǰUС(Ҫʹ) */
		SecterSize = 1 << CH378ReadVar8( VAR8_DISK_SEC_LEN );	 /* ǰUÿС */  

		/*****************************************************************************/
		/* ʾļ */	
		printf("Create Long Name File Test:\n" );	
		memcpy( LongNameBuf, LongName, sizeof( LongName ) );	 /* ƳļLongNameBuf */        
		LongNameBuf[ sizeof( LongName ) ] = 0x00;
		LongNameBuf[ sizeof( LongName ) + 1 ] = 0x00;			 /* ļĩβ0ʾ */			

		/*****************************************************************************/
		/* ʾļ */	
		printf("Create Long Name File Test:\n" );	
		strcpy( buf, "\\ļ.TXT" ); 						 /* óļANSIļ(8+3ʽ) */
		status = CH378CreateLongName( buf, LongNameBuf );		 /* ļļ */	
		if( status == ERR_SUCCESS )
		{
			printf("Create Long Name File OK!!!\n" );
		}
		else
		{
			printf("Create Long Name File Error Code: %02X\n", (UINT16)status );
		}
	
		/*****************************************************************************/
		/* ʾĿ¼ */		        
		printf("Create Long Name Direct Test:\n" );
		memcpy( LongNameBuf, LongDir, sizeof(LongDir) );		 /* ƳĿ¼LongNameBuf */
		LongNameBuf[ sizeof( LongDir ) ] = 0x00;
		LongNameBuf[ sizeof( LongDir ) + 1 ] = 0x00;			 /* ĩβ0ʾ */			
		strcpy( buf, "\\C51\\Ŀ¼" ); 					 	 /* óļANSIļ(8+3ʽ) */
		status = CH378CreateLongDir( buf, LongNameBuf );
		if( status == ERR_SUCCESS )
		{
			printf( "Created Long Dir OK!!\n" );
		}
		else
		{
			printf( "Error Code: %02X\n", (UINT16)status );
		}

		/*****************************************************************************/
		/* ʾȡļӦĳļĿ¼(ͨĶļ(Ŀ¼)·лȡ) */		
		printf("Get Long Name File Test:\n" );	
		strcpy( buf, "\\ļ.TXT" );				 		 /* ļ(Ŀ¼)· */
		status = CH378GetLongName( buf, LongNameBuf );
		if( status == ERR_SUCCESS )
		{
			printf("Long Name:\n" );
			for( i = 0; i != LONG_NAME_BUF_LEN; i++ )
			{
				printf( "%02X ", (UINT16)LongNameBuf[ i ] );
				if( ( LongNameBuf[ i ] == 0 ) && ( LongNameBuf[ i + 1 ] == 0 ) )
				{
					break;
				}	
			}
			printf( "\n" );
		}
		else
		{
			printf( "Error Code: %02X\n", (UINT16)status );
		}

		/*****************************************************************************/
		/* ʾȡļӦĶļ: 
		   ע: 1ҪļĿ¼·,ԱݵĻȡ;
		         2Ҫĳļ; */		
		printf("Get Short Name File Test:\n" );	
		strcpy( buf, "\\" );				 					 /* ļ(Ŀ¼)· */
		status = CH378GetShortName( buf, LongNameBuf );
		if( status == ERR_SUCCESS )
		{
			printf("Short Name:\n" );
			for( i = 0; i != sizeof( buf ); i++ )
			{
				printf( "%02X ", (UINT16)buf[ i ] );
				if( buf[ i ] == 0 )
				{
					break;
				}	
			}
			printf( "\n" );
		}
		else
		{
			printf( "Error Code: %02X\n", (UINT16)status );
		}
	
		/*****************************************************************************/
		/* ʾͨļļݶȡ: 
		   ע: 1ҪļĿ¼·,ԱݵĻȡ;
		         2Ҫĳļ; */
		printf( "Open Long File \n" );
		strcpy( buf, "\\" );				 					 /* ļ(Ŀ¼)· */
		status = CH378OpenLongName( buf, LongNameBuf );			 /* ͨļļ */
		if( status == ERR_SUCCESS )
		{  
			/* ļڲѾ,ƶļָ뵽βԱ */
			printf( "File Size = %ld\n", CH378GetFileSize( ) );  /* ȡǰļ */
			printf( "Locate Tail\n" );
			status = CH378ByteLocate( 0xFFFFFFFF );  			 /* Ƶļβ */
			mStopIfError( status );
		}
		else 
		{
			mStopIfError( status );  							 /* ļʱ */
		}

		printf( "Write Begin\n" );
		len = sprintf( buf, "ǰļ= %ld ֽ\xd\xa", CH378GetFileSize( ) );  /* עַȲbuf,Ӵ󻺳߷ֶд */
		status = CH378ByteWrite( buf, len, NULL );  			 /* ֽΪλļд */
		mStopIfError( status );

		printf( "Close\n" );
		status = CH378FileClose( TRUE );  						 /* رļ,Զļ,ֽΪλдļ,óرļԱԶļ */
		mStopIfError( status );

#if 0
		/*****************************************************************************/
		/* ʾͨļɾļ: 
		   ע: 1ҪļĿ¼·,ԱݵĻȡ;
		         2Ҫĳļ; */
		printf( "Erase Long File \n" );
		strcpy( buf, "\\" );				 					 /* ļ(Ŀ¼)· */
		status = CH378EraseLongName( buf, LongNameBuf );		 /* ͨļɾļ */
		if( status == ERR_SUCCESS )
		{  
			printf( "Success \n" );		
		}
		else
		{
			printf( "Error Code: %02X\n", (UINT16)status );
		}
#endif

UnknownUsbDevice:
		printf( "Take out\n" );
		while( CH378DiskConnect( ) == ERR_SUCCESS ) 
		{  
			/* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}


