/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378 ļϵͳӳ(EXAM1)
*                      USB Host File Interface for CH378
*					   TC2.0@PC, KC7.0@MCS51
*******************************************************************************/



/******************************************************************************
˵: 
    MCS-51ƬCԵUļдʾ    
    ʾֽڶд,ļö,ļ, ڽUе/C51/CH378HFT.CļеСдĸתɴдĸ, д½ļNEWFILE.TXT,
    ҲԭļCH378HFT.C, ôóʾC51Ŀ¼CH378ͷļ, ½NEWFILE.TXTļдʾϢ,
    ҲC51Ŀ¼, ôóʾĿ¼µļ, ½NEWFILE.TXTļдʾϢ    
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "CH378INC.H"											 /* CH378ͷļ */	
#include "HAL.H"												 /* Ӳͷļ */
#include "HAL_BASE.C"											 /* Ӳӳļ */
#include "DEBUG.H"												 /* ӳͷļ */
#include "DEBUG.C"												 /* ӳļ */

/*******************************************************************************/
/* ѡͨѶӿ */
#define	IC_OP_INTERFACE_MODE	 2							 	 /* оƬӿģʽ(1:Ӳ;  2:ģⲢ; 
                                                                    	                 3:ӲSPI; 4:ģSPI; 5:첽) */                                                                    
#if    ( IC_OP_INTERFACE_MODE == 1 )
#include "PARA_HW.C"											 /* Ӳ߲ӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 2 )
#include "PARA_SW.C"										 	 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
#include "SPI_HW.C"										 	 	 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
#include "SPI_SW.C"												 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
#include "UART_HW.C"										 	 /* Ӳ첽ӷʽ */
#else
#error: You Must Include Right Interface Operate File!!!
#endif

/*******************************************************************************/
/* ѡҪĺ */
//#define EN_DISK_QUERY		  	   1							 /* ѯʣռѯӳ */
//#define EN_DIR_CREATE			   1							 /* ½༶Ŀ¼ӳ */	
//#define EN_SECTOR_ACCESS     	   1							 /* Ϊλдļӳ */		
//#define EN_LONG_NAME	   		   1							 /* ֳ֧ļӳ */		
//#define EN_OTHER_FUNCTION   	   1							 /* ǳӳ */		

#include "FILE_SYS.H"											 /* ļϵͳͷļ */
#include "FILE_SYS.C"											 /* ļϵͳӳļ */

/*******************************************************************************/
/*  */
UINT8  buf[ 64 ];												 /* ݻ */

/*******************************************************************************
* Function Name  : CopyAndConvertFile
* Description    : ļ,ֽڷʽ
*                  ע⣺ӲⲿRAMΪݸƻ,ԽٶԽ
* Input          : SrcFileName---Դļ,֧·ָͶ༶Ŀ¼
*				   TarFileName---Ŀļ,֧·ָͶ༶Ŀ¼
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 CopyAndConvertFile( PUINT8 SrcFileName, PUINT8 TarFileName ) 
{  
	UINT8  s;
	UINT16 ThisLen, cnt;
	UINT32 FileSize, ByteCount;

	FileSize = 0;
	ByteCount = 0;
	do 
	{
		/* Դļ */
		printf( "OpenSrc\n" );  								 /* עӡ˷ʱ,ƽٶ */
		s = CH378FileOpen( SrcFileName );  						 
		if( s != ERR_SUCCESS ) 
		{
			return( s );
		}	
		if( ByteCount == 0 ) 
		{  
			/* ״ν */
			FileSize = CH378GetFileSize( );  					 /* ȡǰļ */
			printf( "SrcFileSz=%ld\n", FileSize );
		}
		else 
		{  
			/* ٴν */
			s = CH378ByteLocate( ByteCount );  					 /* ֽΪλƶǰļָ뵽ϴθƽλ */
			if( s != ERR_SUCCESS ) 
			{
				return( s );
			}
		}

		/* ֽڷʽȡԴļ */
		printf( "Read\n" );
		s = CH378ByteRead( buf, sizeof( buf ), &ThisLen );  	 /* ֽΪλӵǰλöȡݿ,󳤶ͬС,ʵʳThisLen */
		if( s != ERR_SUCCESS ) 
		{
			return( s );
		}
#if  0
		s = CH378FileClose( FALSE );  							 /* رļ,ڶԲعرļ */
		if( s != ERR_SUCCESS ) 
		{
			return( s );
		}
#endif

		/* еСдַתΪд */
		for( cnt = 0; cnt < ThisLen; cnt ++ ) 
		{  
			s = buf[ cnt ];
			if( s >= 'a' && s <= 'z' ) 
			{
				buf[ cnt ] = s - ( 'a' - 'A' );
			}
		}

		/* ½Ŀļ */
		if( ByteCount == 0 ) 
		{  
			/* ״,Ŀļδ */
			printf( "CreateTar\n" );
			s = CH378FileCreate( TarFileName );  				 /* ½ļ,ļѾôɾ */
			if( s != ERR_SUCCESS ) 
			{
				return( s );
			}
		}
		else 
		{  
			/* ٴν,ĿļѴ */
			printf( "OpenTar\n" );
			s = CH378FileOpen( TarFileName );  					  /* ļ */
			if( s != ERR_SUCCESS ) 
			{
				return( s );
			}
			s = CH378ByteLocate( ByteCount );  					  /* ֽΪλƶǰļָ뵽ϴθƽλ */
			if( s != ERR_SUCCESS ) 
			{
				return( s );
			}
		}

		/* ȡд뵽Ŀļ */
		printf( "Write\n" );
		s = CH378ByteWrite( buf, ThisLen, NULL );  				  /* ֽΪλǰλдݿ,ûд̿ռ,򷵻ʵʳThisLen */
		if( s != ERR_SUCCESS ) 
		{
			return( s );
		}

		/* رղĿļ */
		printf( "CloseTar\n" );
		s = CH378FileClose( TRUE );  							  /* رļ,ֽڶдԶļ */
		if( s != ERR_SUCCESS ) 
		{
			return( s );
		}
		ByteCount += ThisLen;
		if( ThisLen < sizeof( buf ) ) 
		{  
			/* ʵʶֽСֽ,˵ԭļ */
			if( ByteCount != FileSize ) 
			{
				printf( "Error On SourceFile Reading!!!" );
			}
			break;
		}
	}while( ByteCount < FileSize );
	return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main( void ) 
{
	UINT8  status;
	UINT16 i;

	mDelaymS( 100 );  											 /* ʱ100 */
	mInitSTDIO( );  											 /* Ϊüͨڼʾ */

#if    ( IC_OP_INTERFACE_MODE == 1 )
	printf(" MCS51_CH378_PARA_HW V1.2 2015.08.28...\n");		 /* Ӳ߲ӷʽ */						 			 
#elif  ( IC_OP_INTERFACE_MODE == 2 )
	printf(" MCS51_CH378_PARA_SW V1.2 2015.08.28...\n"); 		 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
	printf(" MCS51_CH378_SPI_HW V1.2 2015.08.28...\n"); 		 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
	printf(" MCS51_CH378_SPI_SW V1.2 2015.08.28...\n");			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
	printf(" MCS51_CH378_UART_HW V1.2 2015.08.28...\n");		 /* Ӳ첽ӷʽ */
#else
	printf(" MCS51_CH378_INTERFACE ERROR 2015.08.28...\n");
#endif

	status = mInitCH378Host( );  								 /* ʼCH378 */								 	
	mStopIfError( status );
	/* ·ʼ */

	while( 1 ) 													 
	{
		/* U̻SDǷ,ȴ */
		printf( "Wait Udisk/SD\n" );
		while( CH378DiskConnect( ) != ERR_SUCCESS ) 
		{  
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  										 /* ʱ,ѡ,еUSB洢Ҫʮʱ */
		
		/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,
		   ȴ5*50mS,ҪDiskReady */
		for( i = 0; i < 100; i ++ ) 
		{  
			/* ȴʱ,100*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			status = CH378DiskReady( );  						 /* ʼ̲ԴǷ */
			if( status == ERR_SUCCESS ) 
			{
				break;  										 /* ׼ */
			}
			else if( status == ERR_DISK_DISCON ) 
			{
				goto UnknownUsbDevice; 							 /* ⵽Ͽ,¼Ⲣʱ */
			}
			if( CH378GetDiskStatus( ) >= DEF_DISK_MOUNTED && i >= 5 ) 
			{
				break;  										 /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
			}
		}
		if( status == ERR_DISK_DISCON ) 
		{  
			/* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;
		}
		if( CH378GetDiskStatus( ) < DEF_DISK_MOUNTED ) 
		{  
			/* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
		
		/* Ҫ,ԶȡݿCH378_CMD_DATA.DiskMountInq,س */
		i = CH378ReadReqBlock( buf );
		if( i == sizeof( INQUIRY_DATA ) ) 
		{  
			/* U̵ĳ̺ͲƷϢ */
			buf[ i ] = 0;
			printf( "Udisk Info: %s\n", ( (P_INQUIRY_DATA)buf) -> VendorIdStr );
		}
		
		/* ȡǰUС(Ҫʹ) */
		SectorSize = 1 << CH378ReadVar8( VAR8_DISK_SEC_LEN );	 /* ǰUÿС */  
	
		/* ȡԭļ */
		printf( "Open\n" );
		status = CH378FileOpen( "\\C51\\CH378HFT.C" );  		 /* Դļ,ļC51Ŀ¼ */
		if( status == ERR_MISS_DIR || status == ERR_MISS_FILE ) 
		{  
			/* ûҵĿ¼ûҵļ */
			/* гļ,öٿԲοEXAM13ȫö */
			if( status == ERR_MISS_DIR ) 
			{
				strcpy( buf, "\\*" );  							 /* C51Ŀ¼гĿ¼µļ */
			}
			else 
			{
				strcpy( buf, "\\C51\\CH378*" );  				 /* CH378HFT.Cļг\C51Ŀ¼µCH378ͷļ */
			}
			
			printf( "List file %s\n", buf );
			status = CH378FileOpen( buf );  					 /* öٶ༶Ŀ¼µļĿ¼ */
			while( status == USB_INT_DISK_READ ) 
			{  
				/* öٵƥļ */
				CH378ReadReqBlock( buf );  						 /* ȡöٵļ· */
				printf( "***EnumName: %s\n",buf );				 /* ӡ,ԭʼ8+3ʽ,δɺСָ */
				xWriteCH378Cmd( CMD0H_FILE_ENUM_GO );  			 /* öļĿ¼ */
				xEndCH378Cmd( );
				status = Wait378Interrupt( );
			}
			if( status != ERR_MISS_FILE ) 
			{
				mStopIfError( status );  						 /*  */
			}

			printf( "Create\n" );
			status = CH378FileCreate( "\\NEWFILE.TXT" );  		 /* ½༶Ŀ¼µļ,ֶ֧༶Ŀ¼· */
			mStopIfError( status );

			printf( "Write\n" );
			strcpy( buf, "Ҳ/C51/CH378HFT.Cļ\xd\n" );
			status = CH378ByteWrite( buf, strlen(buf), NULL );   /* ֽΪλǰλдݿ */
			mStopIfError( status );

			printf( "Close\n" );
			status = CH378FileClose( TRUE );  					 /* رļ,ֽڶдԶļ */
			mStopIfError( status );
		}
		else 
		{  
			/* ҵļ߳ */
			mStopIfError( status );
			status = CopyAndConvertFile( "\\C51\\CH378HFT.C", "\\NEWFILE.TXT" ); /* ļ */			
			mStopIfError( status );
		}
	
		/* ɾĳļ */
		printf( "Erase\n" );
		status = CH378FileErase( "/OLD.TXT" );  				/* ɾļ */
		if( status != ERR_SUCCESS ) 
		{
			printf( "Error: %02X\n", (UINT16)status );  		 /* ʾ */
		}
	
UnknownUsbDevice:
		printf( "Take out\n" );
		while( CH378DiskConnect( ) == ERR_SUCCESS ) 
		{  
			/* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}


