/********************************** (C) COPYRIGHT *******************************
* File Name          : SPI_HW.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378оƬ CH378оƬ Ӳ׼SPIӵӲ V1.2
*                      ṩI/Oӿӳ
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include "HAL.H"

/*******************************************************************************/
/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ    CH378оƬ
      P1.4                 SCS
      P1.5                 SDI
      P1.6                 SDO
      P1.7                 SCK      */
sbit	 	P14			=		   P1^4;
sbit		P16			=		   P1^6;
#define	CH378_SPI_SCS			   P14							 /* ٶCH378SCS */
#define	CH378_SPI_SDO			   P16							 /* ٶCH378SDO */

sfr	SPDR = 0x86;												 /* SPIݼĴ */
sfr	SPSR = 0xAA;												 /* SPI״̬Ĵ */
sfr	SPCR = 0xD5;    											 /* SPIƼĴ */
#define	SPI_IF_TRANS	0x80									 /* SPIֽڴɱ־,SPSRλ7 */

#define CH378_INT_WIRE			INT0							 /* ٶCH378INT#,δôҲͨѯжSDO״̬ʵ */

/*******************************************************************************
* Function Name  : CH378_Port_Init
* Description    : CH378˿ڳʼ
*                  ʹSPIдʱ,Խгʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378_Port_Init( void )  
{
	/* ӲSPIӿ,ôʹmode3(CPOL=1&CPHA=1)mode0(CPOL=0&CPHA=0),
	   CH378ʱز,½,λǸλǰ */
	CH378_SPI_SCS = 1;  										 /* ֹSPIƬѡ */
	
	/* ˫I/OģSPIӿ,ôڴSPI_SCS,SPI_SCK,SPI_SDIΪ,
	   SPI_SDOΪ뷽 */
	/* SPIģʽ3, DORD=0(MSB first), CPOL=1, CPHA=1, CH378Ҳ֧SPIģʽ0 */
	SPCR = 0x5C;  	
}

/*******************************************************************************
* Function Name  : mDelay0_5uS
* Description    : ʱ0.5uS
*                  ʱ0.5uS,ݵƬƵ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mDelay0_5uS( void ) 
{
}

/*******************************************************************************
* Function Name  : Spi376Exchange
* Description    : ӲSPI8λ
* Input          : d---Ҫ뵽CH378
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 Spi376Exchange( UINT8 d )  
{  
	/* Ϊٶ,ԽӳɺԼӳò */
	SPDR = d;  													 /* ȽдSPIݼĴ,ȻѯSPI״̬ĴԵȴSPIֽڴ */
	while( ( SPSR & SPI_IF_TRANS ) == 0 );  					 /* ѯSPI״̬ĴԵȴSPIֽڴ */
	SPSR &= ~ SPI_IF_TRANS;  									 /* SPIֽڴɱ־,еĵƬԶ */
	return( SPDR );  											 /* ȲѯSPI״̬ĴԵȴSPIֽڴ,ȻSPIݼĴ */
}

#define	xEndCH378Cmd( )	{ CH378_SPI_SCS = 1; }  				 /* SPIƬѡЧ,CH378,SPIӿڷʽ */

/*******************************************************************************
* Function Name  : xWriteCH378Cmd
* Description    : CH378д
* Input          : mCmd---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Cmd( UINT8 mCmd )  
{

	CH378_SPI_SCS = 1;  										 /* ֹ֮ǰδͨxEndCH378CmdֹSPIƬѡ */

	/* ˫I/OģSPIӿ,ôȷѾSPI_SCS,SPI_SCK,SPI_SDIΪ,SPI_SDOΪ뷽 */
	CH378_SPI_SCS = 0;  										 /* SPIƬѡЧ */
	Spi376Exchange( mCmd );  									 /*  */
	mDelay0_5uS( ); 
	mDelay0_5uS( ); 
	mDelay0_5uS( );  											 /* ʱ1.5uSȷдڴ1.5uS */
}

#ifdef	FOR_LOW_SPEED_MCU  										 /* Ҫʱ */

#define	xWriteCH378Data( d )	   { Spi376Exchange( d ); }  	 /* CH378д */
#define	xReadCH378Data( )		   ( Spi376Exchange( 0xFF ) )  	 /* CH378 */

#else

/*******************************************************************************
* Function Name  : xWriteCH378Data
* Description    : CH378д
* Input          : mData---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Data( UINT8 mData ) 
{
	Spi376Exchange( mData );
}

/*******************************************************************************
* Function Name  : xReadCH378Data
* Description    : CH378
* Input          : None
* Output         : None
* Return         : ضȡ
*******************************************************************************/
UINT8 xReadCH378Data( void ) 
{
	return( Spi376Exchange( 0xFF ) );
}
#endif

/*******************************************************************************
* Function Name  : Query378Interrupt
* Description    : ѯCH378ж(INT#͵ƽ)
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 Query378Interrupt( void )
{
	/* CH378жֱӲѯж */
	/* δCH378жѯжSDO״̬ */
#ifdef	CH378_INT_WIRE
	return( CH378_INT_WIRE ? FALSE : TRUE );  
#else
	return( CH378_SPI_SDO ? FALSE : TRUE );  
#endif
}

/*******************************************************************************
* Function Name  : mInitCH378Host
* Description    : ʼCH378
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 mInitCH378Host( void ) 
{
	UINT8  res;

	/* CH378Ƿ */	
	CH378_Port_Init( );  										 /* ӿӲʼ */
	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x65 );
	res = xReadCH378Data( );
	xEndCH378Cmd( );
	if( res != 0x9A ) 
	{
		/* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}	

	/* CH378ģʽ */
	xWriteCH378Cmd( CMD11_SET_USB_MODE );  						 /* 豸USBģʽ */
//	xWriteCH378Data( 0x04 );
	xWriteCH378Data( 0x07 );

	/* ȴģʽ,ڲSDҪ10mSʱ,ڲUSB豸Ҫ35mSʱ */	
	mDelaymS( 50 );											 
	res = xReadCH378Data( );
	xEndCH378Cmd( );
#ifndef	CH378_INT_WIRE
#ifdef	CH378_SPI_SDO
	xWriteCH378Cmd( CMD20_SET_SDO_INT );  						 /* SPISDOŵжϷʽ */
	xWriteCH378Data( 0x16 );
	xWriteCH378Data( 0x01 );  									 /* SDOSCSƬѡЧʱж */
	xEndCH378Cmd( );
#endif
#endif
	if( res == CMD_RET_SUCCESS ) 
	{
		return( ERR_SUCCESS );
	}
	else 
	{
		return( ERR_USB_UNKNOWN );  							 /* ģʽ */
	}
}
