/********************************** (C) COPYRIGHT *******************************
* File Name          : SPI_SW.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378оƬ ģSPIӵӲ V1.0
*                      ṩI/Oӿӳ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "stdio.h"
#include "usb_lib.h"
#include "stm32f10x_gpio.h"
#include "../myfile/CH378INC.H"						 				 /* CH378ͷļ */
#include "../myfile/HAL.h"

/*******************************************************************************/
/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ               CH378оƬ
    SPI1_NSS-----PB0            	SCS
    SPI1_SCK-----PA5            	SCK      
    SPI1_MISO----PA6            	SDO
    SPI1_MOSI----PA7            	SDI
    INT#---------PA1                INT#
*/
#define CH378_SPI_SCS_LOW( )       ( GPIOB->BRR  = GPIO_Pin_0 )  /* SPIƬѡ͵ƽ */
#define CH378_SPI_SCS_HIGH( )      ( GPIOB->BSRR = GPIO_Pin_0 )  /* SPIƬѡߵƽ */
#define CH378_SPI_SCK_LOW( )       ( GPIOA->BRR  = GPIO_Pin_5 )  /* SPIʱ͵ƽ */
#define CH378_SPI_SCK_HIGH( )      ( GPIOA->BSRR = GPIO_Pin_5 )  /* SPIʱߵƽ */
#define CH378_SPI_SDI_LOW( )       ( GPIOA->BRR  = GPIO_Pin_7 )  /* SPI͵ƽ */
#define CH378_SPI_SDI_HIGH( )      ( GPIOA->BSRR = GPIO_Pin_7 )  /* SPIߵƽ */
#define	CH378_SPI_SDO_PIN( )	   GPIO_ReadInputDataBit( GPIOA, GPIO_Pin_6 ) /* ȡCH378SPIŵƽ */											 											   

#define CH378_INT_WIRE     1	 
#define	CH378_INT_PIN_WIRE( )	   GPIO_ReadInputDataBit( GPIOA, GPIO_Pin_1 ) /* ٶCH378INT#,δôҲͨѯжSDO״̬ʵ */

/*******************************************************************************
* Function Name  : CH378_PORT_INIT
* Description    : CH378˿ڳʼ
*                  ʹģSPIдʱ,Խгʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378_Port_Init( void )
{
	GPIO_InitTypeDef GPIO_InitStructure;

	/* SPIӿڶӦSCS(PB0)SCK(PA5)MOSI(PA7)Ϊ */		
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_7;			                	
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;			 /* ʽ */
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;                               	
	GPIO_Init( GPIOA, &GPIO_InitStructure );

  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;			                	
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;			 /* ʽ */
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;                               	
	GPIO_Init( GPIOB, &GPIO_InitStructure );
	
	/* MISO(PA6)INT#(PA1)Ϊ */		
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1 | GPIO_Pin_6;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;  				 /*  */
    GPIO_Init( GPIOA, &GPIO_InitStructure );	
        
	/* SCS(PB0)SCK(PA5)MOSI(PA7)Ĭƽ */
	CH378_SPI_SCS_HIGH( );
	CH378_SPI_SCK_HIGH( );
	CH378_SPI_SDI_HIGH( );
}

/*******************************************************************************
* Function Name  : xWriteCH378Cmd
* Description    : CH378д
* Input          : mCmd---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Cmd( UINT8 mCmd ) 
{
	UINT8  i;

	CH378_SPI_SCS_HIGH( );  									 /* ֹ֮ǰδͨxEndCH378CmdֹSPIƬѡ */

	/* ˫I/OģSPIӿ,ôȷѾSPI_SCS,SPI_SCK,SPI_SDIΪ,SPI_SDOΪ뷽 */
	i = 8;
	CH378_SPI_SCS_LOW( ); 										 /* SPIƬѡЧ */
	while( i-- )
   	{
		CH378_SPI_SCK_LOW( );
		if( mCmd & 0x80 ) 
		{
			CH378_SPI_SDI_HIGH( );
		}
		else 
		{
			CH378_SPI_SDI_LOW( );
		}
		mCmd <<= 1;  											 /* λǸλǰ */
		CH378_SPI_SCK_HIGH( );  								 /* CH378ʱز */
	}
	mDelayuS( 2 );  											 /* ʱ2uSȷдڴ2uS,һе״̬ѯ */
}

/*******************************************************************************
* Function Name  : xWriteCH378Data
* Description    : CH378д
* Input          : mData---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Data( UINT8 mData )  
{
	UINT8  i;

	i = 8;
	while( i-- )
   	{
		CH378_SPI_SCK_LOW( );
		if( mData & 0x80 ) 
		{
			CH378_SPI_SDI_HIGH( );
		}
		else 
		{
			CH378_SPI_SDI_LOW( );
		}
		mData <<= 1;  											 /* λǸλǰ */
		CH378_SPI_SCK_HIGH( );  								 /* CH378ʱز */
	}
}

/*******************************************************************************
* Function Name  : xReadCH378Data
* Description    : CH378
* Input          : None
* Output         : None
* Return         : ضȡ
*******************************************************************************/
UINT8 xReadCH378Data( void )  
{
	/* ӲSPIӿ,ӦȲѯSPI״̬ĴԵȴSPIֽڴ,ȻSPIݼĴ */
	UINT8  i, d;
	
	d = 0;
	i = 8;
	while( i-- )
   	{
		CH378_SPI_SCK_LOW( );							 		 /* CH378ʱ½ */
		CH378_SPI_SCK_LOW( );
		d <<= 1;  												 /* λǸλǰ */
		if( ( GPIOA->IDR & GPIO_Pin_6 ) != 0x00 ) 
		{
			d++;
		}
		CH378_SPI_SCK_HIGH( );
	}
	return( d );
}

#define	xEndCH378Cmd( )			   { CH378_SPI_SCS_HIGH( ); }  	 /* SPIƬѡЧ,CH378,SPIӿڷʽ */

/*******************************************************************************
* Function Name  : Query378Interrupt
* Description    : ѯCH378ж(INT#͵ƽ)
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 Query378Interrupt( void )
{
	/* CH378жֱӲѯж */
	/* δCH378жѯжSDO״̬ */
#ifdef	CH378_INT_WIRE
	return( CH378_INT_PIN_WIRE( ) ? FALSE : TRUE );  
#else
	return( CH378_SPI_SDO_PIN( ) ? FALSE : TRUE );  
#endif
}

/*******************************************************************************
* Function Name  : mInitCH378Host
* Description    : ʼCH378
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 mInitCH378Host( void ) 
{
	UINT8  res;

	/* CH378Ƿ */
	CH378_Port_Init( );  										 /* ӿӲʼ */
	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x65 );
	res = xReadCH378Data( );
	xEndCH378Cmd( );
	if( res != 0x9A ) 
	{
		/* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}	
	
	/* CH378ģʽ */	
	xWriteCH378Cmd( CMD11_SET_USB_MODE );  					 	 /* 豸USBģʽ */
//	xWriteCH378Data( 0x04 );									 /* SD */
	xWriteCH378Data( 0x07 );									 /* USB洢豸 */

	/* ȴģʽ,ڲSDҪ10mSʱ,ڲUSB豸Ҫ35mSʱ */	
	mDelaymS( 50 );											 
	res = xReadCH378Data( );
	xEndCH378Cmd( );
#ifndef	CH378_INT_WIRE
	xWriteCH378Cmd( CMD20_SET_SDO_INT );  						 /* SPISDOŵжϷʽ */
	xWriteCH378Data( 0x16 );
	xWriteCH378Data( 0x01 );  									 /* SDOSCSƬѡЧʱж */
	xEndCH378Cmd( );
#endif
	if( res == CMD_RET_SUCCESS ) 
	{
		return( ERR_SUCCESS );
	}
	else 
	{
		return( ERR_USB_UNKNOWN );  							 /* ģʽ */
	}
}
