/********************************** (C) COPYRIGHT *******************************
* File Name          : UART.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378оƬ Ӳ׼첽ӵӲ V1.0
*                      ṩI/Oӿӳ
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include "stm32f10x_usart.h"
#include "../myfile/HAL.h"										 /* CH378Ӳͷļ */	

/*******************************************************************************/
/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ               CH378оƬ
    UART2_TXD----PA2                RXD
    UART2_RXD----PA3         	    TXD       
    INT#---------PA1                INT#
*/
      
#define CH378_INT_WIRE     1	 
#define	CH378_INT_PIN_WIRE( )	   GPIO_ReadInputDataBit( GPIOA, GPIO_Pin_1 ) /* ٶCH378INT#,δôҲͨѯжSDO״̬ʵ */

#define	UART_INIT_BAUDRATE		   9600							 /* ĬͨѶ9600bps,ͨӲ趨ֱѡߵCH378ĬͨѶ */
//#define	UART_WORK_BAUDRATE		   57600					 /* ʽͨѶ57600bps */
#define	UART_WORK_BAUDRATE		   115200					 /* ʽͨѶ115200bps */
//#define	UART_WORK_BAUDRATE		   230400					 /* ʽͨѶ230400bps */
//#define	UART_WORK_BAUDRATE		   460800					 /* ʽͨѶ460800bps */
//#define	UART_WORK_BAUDRATE		   921600					 /* ʽͨѶ921600bps */
//#define	UART_WORK_BAUDRATE		   1843200						 /* ʽͨѶ1843200bps */
//#define	UART_WORK_BAUDRATE		   3686400					 /* ʽͨѶ3686400bps() */
//#define	UART_WORK_BAUDRATE		   7812500					 /* ʽͨѶ7812500bps() */
         
/*******************************************************************************
* Function Name  : USART2_Configuration
* Description    : 2ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USART2_Configuration( UINT32 baudrate )
{
	USART_InitTypeDef USART_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructure;

	/* UART2 clock enable */
	RCC_APB1PeriphClockCmd( RCC_APB1Periph_USART2, ENABLE );	 /* ʹUART2 */

	/* USART2 Hard configured: */
	/* Configure USART2 Rx (PA3) as input floating */
	GPIO_InitStructure.GPIO_Pin   = GPIO_Pin_3;
	GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_IN_FLOATING;
	GPIO_Init( GPIOA, &GPIO_InitStructure );

	/* Configure USART2 Tx (PA2) as alternate function push-pull */
	GPIO_InitStructure.GPIO_Pin   = GPIO_Pin_2;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AF_PP;
	GPIO_Init( GPIOA, &GPIO_InitStructure );

  	/* USART2 configured as follow:
        - BaudRate = 115200 baud  
        - Word Length = 8 Bits
        - One Stop Bit
        - No parity
        - Hardware flow control disabled (RTS and CTS signals)
        - Receive and transmit enabled
        - USART Clock disabled
        - USART CPOL: Clock is active low
        - USART CPHA: Data is captured on the middle 
        - USART LastBit: The clock pulse of the last data bit is not output to 
                         the SCLK pin
  	*/

	USART_InitStructure.USART_BaudRate = baudrate;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init( USART2, &USART_InitStructure );

	/* Enable USART2 */
	USART_Cmd( USART2, ENABLE ); 
}

/*******************************************************************************
* Function Name  : USART2_Send_Byte
* Description    : 2һֽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USART2_Send_Byte( UINT8 dat )
{
	USART2->DR = ( dat & (uint16_t)0x01FF );								
	while( !( USART2->SR & USART_FLAG_TXE ) ); 		
}

/*******************************************************************************
* Function Name  : CH378_Port_Init
* Description    : CH378˿ڳʼ
*                  ʹ첽ڶдʱ,Խгʼ  
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378_Port_Init( void ) 
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	USART2_Configuration( UART_INIT_BAUDRATE );
	
	/* INT#(PA1)Ϊ */		
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;  				 /*  */
    GPIO_Init( GPIOA, &GPIO_InitStructure );		
}

#ifdef UART_WORK_BAUDRATE
/*******************************************************************************
* Function Name  : Set_MCU_BaudRate
* Description    : õƬ
*                  ƬлʽͨѶ 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Set_MCU_BaudRate( void )  								 
{
	USART2_Configuration( UART_WORK_BAUDRATE );
}
#endif

/*******************************************************************************
* Function Name  : xWriteCH378Cmd
* Description    : CH378д
* Input          : mCmd---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Cmd( UINT8 mCmd ) 
{
	USART2_Send_Byte( SER_SYNC_CODE1 );							 /* ĵ1ͬ */
	USART2_Send_Byte( SER_SYNC_CODE2 );							 /* ĵ2ͬ */
	USART2_Send_Byte( mCmd );							 		 /*  */
	mDelayuS( 2 );  											 /* ʱ2uSȷдڴ2uS */
}

/*******************************************************************************
* Function Name  : xWriteCH378Data
* Description    : CH378д
* Input          : mData---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Data( UINT8 mData ) 
{
	USART2_Send_Byte( mData );  								 /*  */
}

/*******************************************************************************
* Function Name  : xReadCH378Data
* Description    : CH378
* Input          : None
* Output         : None
* Return         : ضȡ
*******************************************************************************/
UINT8 xReadCH378Data( void )  
{
	UINT32 i;
	
	for( i = 0; i < 0xFFFFF0; i ++ ) 
	{  
		/* ֹʱ */		
		if( USART2->SR & USART_FLAG_RXNE ) 
		{  
			/* ڽյ */
			return( ( UINT8 )( USART2->DR & (uint16_t)0x01FF ) );/*  */
		}
	}
	return( 0xff );  												 /* Ӧ÷ */
}

#define	xEndCH378Cmd( )  										 /* CH378,SPIӿڷʽ */

/*******************************************************************************
* Function Name  : Check_Cmd_OpStatus
* Description    : ִ״̬
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 Check_Cmd_OpStatus( void ) 
{
	UINT8  res;	

	xWriteCH378Cmd( CMD11_READ_VAR8 );
	xWriteCH378Data( VAR8_CMD_OP_STATUS );						  /* ȡһִ״̬ */
	res = xReadCH378Data( );
	xEndCH378Cmd( );
	return( res );
}

/*******************************************************************************
* Function Name  : Query378Interrupt
* Description    : ѯCH378ж(INT#͵ƽ)
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 Query378Interrupt( void )
{
	UINT8  dat = 0;

	/* CH378жֱӲѯж */
	/* δCH378жѯж״̬ */
#ifdef	CH378_INT_WIRE
	if( CH378_INT_PIN_WIRE( ) )
	{
		return( FALSE );
	}
	else
	{
		xReadCH378Data( );										 /* ڲֵƬFIFO,Ա뽫صж״̬ */
		return( TRUE );   	
	}
#else
	if( USART2->SR & USART_FLAG_RXNE ) 
	{  
		dat = ( UINT8 )( USART2->DR & (uint16_t)0x01FF );		 /* ȡ */	
		return( TRUE );
	}
	else 
	{
		return( FALSE );
	}
#endif
}

UINT8 CH378GetIntStatus( void );

/*******************************************************************************
* Function Name  : mInitCH378Host
* Description    : ʼCH378
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 mInitCH378Host( void ) 
{
	UINT8  res;

	/* CH378Ƿ */	
	CH378_Port_Init( );  										 /* ӿӲʼ */
	xWriteCH378Cmd( CMD01_GET_IC_VER );  						 /* ԵƬCH378֮ͨѶӿ */
	res = xReadCH378Data( );
    printf( "Ver: %02X\n", (UINT16)res );
	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x65 );
	res = xReadCH378Data( );
	printf( "CHECK_EXIST: %02X\n", (UINT16)res );
	if( res != 0x9A ) 
	{
		/* ͨѶӿڲ,ԭ: ӿ쳣,豸Ӱ(ƬѡΨһ),
		   ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}
	
#ifdef	UART_WORK_BAUDRATE
	/* CH378ͨŲ */
	xWriteCH378Cmd( CMD31_SET_BAUDRATE );  						 /* ôͨѶ */
	xWriteCH378Data( (UINT8)UART_WORK_BAUDRATE );
	xWriteCH378Data( (UINT8)( UART_WORK_BAUDRATE >> 8 ) );
	xWriteCH378Data( (UINT8)( UART_WORK_BAUDRATE >> 16 ) );
	xEndCH378Cmd( );  											 /* 첽ڷʽҪ */

	/* õƬͨŲ */
	mDelaymS( 3 );  
	Set_MCU_BaudRate( );  										 /* ƬлʽͨѶ */

	/* ͨȡִ״̬жϸǷִгɹ */
	if( Check_Cmd_OpStatus( ) != CMD_RET_SUCCESS ) 
	{
		return( ERR_USB_UNKNOWN );  							 /* ͨѶлʧ,ͨӲλCH378 */
	}
#endif

	/* CH378ģʽ */
	xWriteCH378Cmd( CMD11_SET_USB_MODE );  						 /* 豸USBģʽ */
//	xWriteCH378Data( 0x04 );									 /* SD */
	xWriteCH378Data( 0x07 );									 /* USB洢豸 */

	/* ȴģʽ,ڲSDҪ10mSʱ,ڲUSB豸Ҫ35mSʱ */	
	mDelaymS( 50 );											 
	res = xReadCH378Data( );
	xEndCH378Cmd( );  											 /* 첽ڷʽҪ */
	if( res == CMD_RET_SUCCESS ) 
	{
		return( ERR_SUCCESS );
	}
	else 
	{
		/* ͨѯһִ״̬жϸǷִгɹ */
		if( Check_Cmd_OpStatus( ) == CMD_RET_SUCCESS ) 
		{
			return( ERR_SUCCESS );
		}
		return( ERR_USB_UNKNOWN );  							 /* ģʽ */
	}
}


