/********************************** (C) COPYRIGHT *******************************
* File Name          : UART.C
* Author             : MJX
* Version            : V1.2
* Date               : 2015/08/28
* Description        : CH378оƬ Ӳ׼첽ӵӲ V1.2
*                      ṩI/Oӿӳ
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include "HAL.H"

/*******************************************************************************/
/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ    CH378оƬ
      TXD                  RXD
      RXD                  TXD       */
#define CH378_INT_WIRE			   INT0							 /* ٶCH378INT#,δôҲͨѯж״̬ʵ */

#define	UART_INIT_BAUDRATE		   9600							 /* ĬͨѶ9600bps,ͨӲ趨ֱѡߵCH378ĬͨѶ */
#define	UART_WORK_BAUDRATE		   57600						 /* ʽͨѶ57600bps */
//#define	UART_WORK_BAUDRATE		   115200					 /* ʽͨѶ115200bps */
//#define	UART_WORK_BAUDRATE		   230400					 /* ʽͨѶ230400bps */
//#define	UART_WORK_BAUDRATE		   460800					 /* ʽͨѶ460800bps */
//#define	UART_WORK_BAUDRATE		   921600					 /* ʽͨѶ921600bps */
//#define	UART_WORK_BAUDRATE		   1843200					 /* ʽͨѶ1843200bps */


/*******************************************************************************
* Function Name  : CH378_Port_Init
* Description    : CH378˿ڳʼ
*                  ʹ첽ڶдʱ,Խгʼ  
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378_Port_Init( void ) 
{
	/* Ƭֻһ,ôֹͨϢ */
	SCON = 0x50;
	PCON = 0x80;
//	TL2 = RCAP2L = 0 - 18432000/32/UART_INIT_BAUDRATE; 			 /* 18.432MHz */
	TL2 = RCAP2L = 0 - 24000000/32/UART_INIT_BAUDRATE; 			 /* 24MHz */

	/* ͨӲ趨ֱѡߵCH378ĬͨѶ */
	TH2 = RCAP2H = 0xFF;
	T2CON = 0x34;  												 /* ʱ2ڴڵĲʷ */
	RI = 0;
}

#ifdef UART_WORK_BAUDRATE
/*******************************************************************************
* Function Name  : Set_MCU_BaudRate
* Description    : õƬ
*                  ƬлʽͨѶ 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Set_MCU_BaudRate( void )  								 
{
//	TL2 = RCAP2L = 0 - 18432000/32/UART_WORK_BAUDRATE; 			 /* 18.432MHz */
	TL2 = RCAP2L = 0 - 24000000/32/UART_WORK_BAUDRATE; 			 /* 24MHz */
	RI = 0;
}
#endif

/*******************************************************************************
* Function Name  : xWriteCH378Cmd
* Description    : CH378д
* Input          : mCmd---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Cmd( UINT8 mCmd ) 
{
	TI = 0;
	SBUF = SER_SYNC_CODE1;  									 /* ĵ1ͬ */
	while( TI == 0 );
	TI = 0;
	SBUF = SER_SYNC_CODE2;  									 /* ĵ2ͬ */
	while( TI == 0 );
	TI = 0;
	SBUF = mCmd;  												 /*  */
	while( TI == 0 );
	RI = 0;														 			
}

/*******************************************************************************
* Function Name  : xWriteCH378Data
* Description    : CH378д
* Input          : mData---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Data( UINT8 mData ) 
{
	TI = 0;
	SBUF = mData;  												 /*  */
	while( TI == 0 );
}

/*******************************************************************************
* Function Name  : xReadCH378Data
* Description    : CH378
* Input          : None
* Output         : None
* Return         : ضȡ
*******************************************************************************/
UINT8 xReadCH378Data( void )  
{
	UINT32 i;
	
	for( i = 0; i < 500000; i ++ ) 
	{  
		/* ֹʱ */
		if( RI ) 
		{  
			/* ڽյ */
			RI = 0;
			return( SBUF );  									 /*  */
		}
	}
	return( 0xff );  											 /* Ӧ÷ */
}

#define	xEndCH378Cmd( )  										 /* CH378,SPIӿڷʽ */


/*******************************************************************************
* Function Name  : Check_Cmd_OpStatus
* Description    : ִ״̬
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 Check_Cmd_OpStatus( void ) 
{
	UINT8  res;	

	xWriteCH378Cmd( CMD11_READ_VAR8 );
	xWriteCH378Data( VAR8_CMD_OP_STATUS );						  /* ȡһִ״̬ */
	res = xReadCH378Data( );
	xEndCH378Cmd( );
	return( res );
}

/*******************************************************************************
* Function Name  : Query378Interrupt
* Description    : ѯCH378ж(INT#͵ƽ)
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 Query378Interrupt( void )
{
	/* CH378жֱӲѯж */
	/* δCH378жѯж״̬ */
#ifdef	CH378_INT_WIRE
	return( CH378_INT_WIRE ? FALSE : TRUE );  
#else
	if( RI ) 
	{  
		RI = 0;
		return( TRUE );
	}
	else 
	{
		return( FALSE );
	}
#endif
}

/*******************************************************************************
* Function Name  : mInitCH378Host
* Description    : ʼCH378
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 mInitCH378Host( void ) 
{
	UINT8  res;

	/* CH378Ƿ */	
	CH378_Port_Init( );  										 /* ӿӲʼ */
	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x65 );
	res = xReadCH378Data( );
	xEndCH378Cmd( );  											 /* 첽ڷʽҪ */
	if( res != 0x9A ) 
	{
		/* ͨѶӿڲ,ԭ: ӿ쳣,豸Ӱ(ƬѡΨһ),
		   ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}
	
#ifdef	UART_WORK_BAUDRATE
	/* CH378ͨŲ */
	xWriteCH378Cmd( CMD31_SET_BAUDRATE );  						 /* ôͨѶ */
	xWriteCH378Data( (UINT8)UART_WORK_BAUDRATE );
	xWriteCH378Data( (UINT8)( UART_WORK_BAUDRATE >> 8 ) );
	xWriteCH378Data( (UINT8)( UART_WORK_BAUDRATE >> 16 ) );
	xEndCH378Cmd( );  											 /* 첽ڷʽҪ */
	
	/* õƬͨŲ */
	mDelaymS( 3 );
	Set_MCU_BaudRate( );  										 /* ƬлʽͨѶ */

	/* ͨȡִ״̬жϸǷִгɹ */
	if( Check_Cmd_OpStatus( ) != CMD_RET_SUCCESS ) 
	{
		return( ERR_USB_UNKNOWN );  							 /* ͨѶлʧ,ͨӲλCH378 */
	}

#endif

	/* CH378ģʽ */
	xWriteCH378Cmd( CMD11_SET_USB_MODE );  						 /* 豸USBģʽ */
//	xWriteCH378Data( 0x04 );									 /* SD */
	xWriteCH378Data( 0x07 );									 /* USB洢豸 */

	/* ȴģʽ,ڲSDҪ10mSʱ,ڲUSB豸Ҫ35mSʱ */	
	mDelaymS( 50 );											 
	res = xReadCH378Data( );
	xEndCH378Cmd( );  											 /* 첽ڷʽҪ */
	if( res == CMD_RET_SUCCESS ) 
	{
		return( ERR_SUCCESS );
	}
	else 
	{
		/* ͨȡִ״̬жϸǷִгɹ */
		if( Check_Cmd_OpStatus( ) == CMD_RET_SUCCESS ) 
		{
			return( ERR_SUCCESS );  							 /* ͨѶлʧ,ͨӲλCH378 */
		}
		return( ERR_USB_UNKNOWN );  							 /* ģʽ */
	}
}
